/**************************************************************
//ESP8266mDNS  включение и выключение WiFi розетки
//*************************************************************/

#include <ESP8266WiFi.h>
#include <ESP8266mDNS.h>
#include <pgmspace.h>   //PROGMEM

#include <IRremoteESP8266.h>
int RECV_PIN = 2;                 //IR detector ( GPIO pin 2 = D4)
//int RECV_PIN = 0;                 //IR detector ( GPIO pin 0 = D3)
IRrecv irrecv(RECV_PIN);
IRsend irsend(15);                 //an IR led is connected to GPIO pin 5 = D1, pin0 = D3
decode_results results;


//html файлы только для чтения
const static char file0[] PROGMEM =
  "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN'>\n\r"
  "<meta http-equiv='Content-Type' content='text/html; charset=UTF-8' />\n\r"
  "<html><head><title>ESP8266 GPIO Control</title>\n\r"
  "<meta name=viewport content=\"width=device-width, initial-scale=1\">\n\r"
  "<style type=\"text/css\">\n\r"
  ".css-checkbox input[type=checkbox] {\n\r"
  "display: none;}\n\r"
  ".css-checkbox label {\n\r"
  "position: relative;\n\r"
  "display: block;\n\r"
  "width: 64px;\n\r"
  "height: 10px;\n\r"
  "padding: 15px;\n\r"
  "border-radius: 50px;\n\r"
  "line-height: 10px;\n\r"
  "color: #31b3ff;\n\r"
  "font-size:48px;\n\r"
  "color: #0F0;\n\r"
  "text-shadow: 1px 1px 0px rgba(255, 255, 255, .15);\n\r"
  "background: rgb(71, 71, 71);\n\r"
  "box-shadow:\n\r"
  " 0 1px 0 rgba(255, 255, 255, .2), inset 0 0 0 5px rgb(60, 60, 60), inset 0 6px 6px rgba(0, 0, 0, .5), inset 0 -6px 1px rgba(255, 255, 255, .2);\n\r"
  "cursor: pointer;}\n\r"
  ".css-checkbox label:before {\n\r"
  "content: \"•\";\n\r"
  "font-size:48px;\n\r"
  "position: absolute;\n\r"
  "right: 15px;\n\r"
  "color: #F00;}\n\r"
  ".css-checkbox label:after {\n\r"
  "content: \"\";\n\r"
  "position: absolute;\n\r"
  "left: 5px;\n\r"
  "top: 5px;\n\r"
  "display: block;\n\r"
  "width: 50px;\n\r"
  "height: 30px;\n\r"
  "border-radius: 50px;\n\r"
  "background: #ccc linear-gradient(#fcfff4 0%, #dfe5d7 40%, #b3bead 100%);\n\r"
  "transition: .5s;}\n\r"
  ".css-checkbox input[type=checkbox]:checked + label:after {\n\r"
  "left: 40px;}\n\r";

const static char file1[] PROGMEM =
  "a {color:#FFF;font-weight:bold;text-decoration:none;}\n\r"
  ".cleared {float : none;clear : both;margin : 0;padding : 0;border : none;font-size : 1px;}\n\r"
  "div.ex_output {\n\r"
  "width:258px;\n\r"
  "text-align:center;\n\r"
  "background-color: #000080;\n\r"
  "margin-left:6px;}\n\r"
  "div.ex_output output {font-weight:bold;font-size:16px;color: #CCC;}\n\r"
  "div.output {\n\r"
  "width:80px;\n\r"
  "background-color: #EFE3CF;\n\r"
  "border: 2px solid #006;\n\r"
  "text-align:center;\n\r"
  "margin-bottom:4px;\n\r"
  "margin-right:2px;\n\r"
  "float:left;}\n\r"
  "</style>\n\r";

const static char file2[] PROGMEM =
  "<script type= \"text/javascript\">\n\r"
  "var get_ver = 1;var str_URL = \"\"; var x = \"\";\n\r"
  "function sel_but(id_cb) {\n\r"
  "str_URL = id_cb.id;\n\r"
  "trans_par(id_cb);}\n\r"
  "function trans_par(id_cb) {\n\r"
  "var go_link = \"?\";\n\r"
  "if (document.getElementById(\"ip\").title != \"#\")  //есть WiFi IP\n\r"
  "{switch (get_ver) {\n\r"
  "case 1: go_link = go_link + \"ip=\" + document.getElementById(\"ip\").title + ';'; break\n\r"
  "case 2: go_link = \"http://\" + document.getElementById(\"ip\").title + \"?ip=192.168.0.128\" + ';'; break\n\r"
  "default: alert(\"no get\"); break}\n\r"
  "if (document.getElementById(\"te2\")) {\n\r"
  "if (document.getElementById(\"te2\").checked) {\n\r"
  "setTimeout(function() {trans_par2(id_cb)} , document.getElementById(\"r_sec\").value * 1000);}}}\n\r"
  "str_URL2 = go_link + document.getElementById(\"pult\").title  + ':' + str_URL;\n\r"
  "trans_get();}\n\r"
  "function trans_par2(id_cb){\n\r"
  "str_URL2 =  \"?\" + document.getElementById(\"pult\").title  + \":\" + str_URL;\n\r"
  "trans_get();}\n\r"
  "function trans_get() {\n\r"
  "var xmlhttp = getXmlHttp(); \n\r"
  "xmlhttp.open(\"GET\", str_URL2, true);\n\r"
  "var http = new XMLHttpRequest(), href = this.href;\n\r"
  "http.open(\"GET\", str_URL2);\n\r"
  "http.setRequestHeader(\"Content-Type\", \"application/x-www-form-urlencoded\");\n\r"
  "xmlhttp.onreadystatechange = function()\n\r"
  "{ if (xmlhttp.readyState == 4) {\n\r"
  "if (xmlhttp.status == 200) {\n\r"
  "x = xmlhttp.responseText;\n\r"
  "getParam(x);}}}\n\r"
  "xmlhttp.send(null);}\n\r"
  "function getXmlHttp() {\n\r"
  "try {return new ActiveXObject(\"Msxml2.XMLHTTP\");}\n\r"
  "catch (e) {try {\n\r"
  "return new ActiveXObject(\"Microsoft.XMLHTTP\");}\n\r"
  "catch (ee) {}} if (typeof XMLHttpRequest != \"undefined\")\n\r"
  "{return new XMLHttpRequest();}}\n\r";

const static char file3[] PROGMEM =
  "function getParam(get) {\n\r"
  "var tmp = new Array(); var tmp2 = new Array(); var param = new Array();\n\r"
  "if (get != \"\") {\n\r"
  "tmp = (get.substr(1)).split(\"&\");\n\r"
  "for (var i = 0; i < tmp.length; i++) {\n\r"
  "tmp2 = tmp[i].split(\"=\");\n\r"
  "param[tmp2[0]] = tmp2[1];}\n\r"
  "for (var key in param) {\n\r"
  "if (param[key] != \"\") {\n\r"
  "if (key.indexOf(\"cb\") >= 0) {\n\r"
  "if (param[key] > 0) {\n\r"
  "document.getElementById(key).checked = true;\n\r"
  "} else {\n\r"
  "document.getElementById(key).checked = false;}\n\r"
  "} else {\n\r"
  "document.getElementById(key).value = param[key];\n\r"
  "}}}}}\n\r"
  "function startTimer() {\n\r"
  "if (document.getElementById(\"pultname\")){\n\r"
  "if (document.getElementById(\"pultname\").textContent == \"wait\")\n\r"
  "{var my_host = unescape(document.location.pathname);\n\r"
  "var r = my_host.substring( my_host.lastIndexOf('/') + 1, my_host.length );\n\r"
  "str_URL = \"pn=\" + my_host.substring( my_host.lastIndexOf('/') + 1, my_host.length );\n\r"
  "trans_par(document.getElementById(\"pultname\"));}}\n\r"
  "var my_timer = document.getElementById(\"my_timer\");\n\r"
  "var time = my_timer.innerHTML;\n\r"
  "var arr = time.split(\":\");\n\r"
  "var h = arr[0];\n\r"
  "var m = arr[1];\n\r"
  "var s = arr[2];\n\r"
  "if (s == 0) {\n\r"
  "if (document.getElementById(\"tt1\").checked) {\n\r"
  "str_URL = \"zz=0\";\n\r"
  "trans_par(document.getElementById(\"ce1\"));}\n\r"
  "s = document.getElementById(\"r_sec\").value;}\n\r"
  "else s--; if (s < 10) s = \"0\" + s;\n\r"
  "if (document.getElementById(\"tt1\").checked) {\n\r"
  "document.getElementById(\"my_timer\").innerHTML = h + \":\" + m + \":\" + s;}\n\r"
  "setTimeout(startTimer, 1000);}\n\r";

const static char file4[] PROGMEM =
  "function polsun_val(id_cb){\n\r"
  "var x = id_cb.id;\n\r"
  "var newstr = x.replace(new RegExp(\"cd\"),\"cb\");\n\r"
  "if (id_cb.value >0)\n\r"
  "{document.getElementById(newstr).checked=true;}else{document.getElementById(newstr).checked=false;}\n\r"
  "str_URL = id_cb.id+\"=\" + id_cb.value;\n\r"
  "document.getElementById(\"result1\").value = str_URL;\n\r"
  "sd_index(id_cb);trans_par(id_cb);}\n\r"
  "function cb_check0(id_cb) {\n\r"
  "y = id_cb.name;  //IP adress\n\r"
  "x = id_cb.id;\n\r"
  "if (id_cb.checked) {\n\r"
  "str_URL = x + \"=1\";\n\r"
  "} else {str_URL = x + \"=0\";}\n\r"
  "if(y !=\"\"){\n\r"
  "var temp_ip = document.getElementById(\"ip\").title;\n\r"
  "document.getElementById(\"ip\").title = y;\n\r"
  "trans_par(id_cb);\n\r"
  "//восстановить значение\n\r"
  "document.getElementById(\"ip\").title = temp_ip;\n\r"
  "}else{\n\r"
  "trans_par(id_cb);}}\n\r"
  "function cb_check(id_cb) {\n\r"
  "x = id_cb.id;\n\r"
  "y = x.replace(\"cb\", \"cd\");\n\r"
  "var rng = document.getElementById(y);\n\r"
  "if (id_cb.checked) {\n\r"
  "str_URL = x + \"=1\";\n\r"
  "rng.value = rng.max; sd_index(id_cb);} else {\n\r"
  "str_URL = x + \"=0\";\n\r"
  "rng.value = rng.min;}\n\r"
  "trans_par(id_cb);}\n\r"
  "function f_rec(id_cb){\n\r"
  "var yyy = document.getElementById(\"rec\").style.display;\n\r"
  "if (yyy == \"none\"){\n\r"
  "document.getElementById(\"rec\").style.display = \"block\";\n\r"
  "str_URL = \"rec=1\";}else{\n\r"
  "document.getElementById(\"rec\").style.display = \"none\";\n\r"
  "str_URL = \"rec=0\";}\n\r"
  "trans_par(id_cb);}\n\r"
  "function cb_tt(id_cb){x = id_cb.id;\n\r"
  "if (id_cb.checked){str_URL=x+\"=\"+ document.getElementById(\"r_sec\").value;}else{str_URL=x+\"=0\";}trans_par(id_cb);}\n\r"
  "</script></head>\n\r";

const static char file5[] PROGMEM =
  "<body onload=\"startTimer()\">\n\r"
  "<div class= \"ex_output\">\n\r"
  "<output id=\"ex_out\"><span>DevKit ESP8266 Control</span></output></div>\n\r"
  "<table width=\"265\" id=\"pult\" title=\"map\">\n\r"
  "<tr bgcolor=\"#E10000\">\n\r"
  "<td width=\"265\">&nbsp;</td></tr></table>\n\r"
  "<br /><div class=\"css-checkbox\" style=\"width:265px; padding-left:74px;\">\n\r"
  "<input type=\"checkbox\" id=\"vv12\"   onclick=\"cb_check0(this)\"/>\n\r"
  "<label for=\"vv12\" >&bull;</label></div><br />\n\r"
  "<table width=\"265\" border=\"1\">\n\r"
  "<tr><th width=\"71\" scope=\"col\">внешний</th>\n\r"
  "<th width=\"112\" scope=\"col\">таймер</th>\n\r"
  "<th width=\"89\" scope=\"col\">внутренний</th></tr>\n\r"
  "<tr><td><input type=\"checkbox\" id=\"te1\" onclick=\"my_timer()\" disabled=\"disabled\" /></td>\n\r"
  "<td><input style=\"width:52px; text-align:center\" type=\"number\" min=\"1\" max=\"59\" step=\"1\" id=\"r_sec\" value=\"4\" onchange=\"timer_on()\" /></td>\n\r"
  "<td><input type=\"checkbox\" id=\"tt1\" onclick=\"cb_tt(this)\" /></td></tr></table>\n\r"
  "<div style=\"width:264px; background-color:#C10000; height:4px\" >&nbsp;</div>\n\r"
  "<div id=\"ip\" title=\"#\"></div>\n\r"
  "</body></html>\n\r";

const char* const string_table[] PROGMEM = {file0, file1, file2, file3, file4, file5};

/*--вариант 2---*/
const char* ssid = "******";                   //имя WiFi сети (WiFi router)
const char* password = "************";   //ключ или пароль WiFi сети (WiFi router)
/*-----2--------*/

//вариант 1 ------
//const char WiFiAPPSK[] = "testwifi"; //свой пароль, сеть будет (что-то вроде ThingDev-A37) IP 192.168.4.1
//--------1-------

int pin = 2;
int sos = 0;
int cikl_avto = 1000; //интервал ~1 сек
int cikl_current = 0; //интервал ~1 сек
String priem = "";
String mess = "";
WiFiServer server(80);
//вариант 1 ------
//WiFiClient client; //ruben
//--------1-------
/*--вариант 2---*/
WiFiClient client = server.available(); //ruben нет в "вариант 1"
/*-----2--------*/
IPAddress ip(192, 168, 0, 130); //Node static IP
IPAddress gateway(192, 168, 0, 1);
IPAddress subnet(255, 255, 255, 0); //- See more at: http://www.esp8266.com/viewtopic.php?f=6&t=3522#sthash.sWvIJ5y5.dpuf
byte out_ip[] = { 192, 168, 0, 8 };
int tt_time = 0;
int cikl_count = 0;
//======================
unsigned int cod_khz = 38;  //частота
unsigned int cod_len = 68;           //кол-во байт в коде

void setup()
{
  initHardware();
    irrecv.enableIRIn();          // Start the receiver

  //setupWiFi();
  //---------вариант 2--------------------------
  // Connect to WiFi network
  WiFi.begin(ssid, password);
  WiFi.config(ip, gateway, subnet);  ////Node static IP установить статический IP адрес
  Serial.println("");

  // Wait for connection
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("R_mDNS_Web_Server_V4");
  Serial.print("Connected to ");
  Serial.println(ssid);
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
  /*
  String str_ip = String(WiFi.localIP()); //192.168.0.104 = 1744873664
  Serial.println(str_ip);
  */
  IPAddress ip = WiFi.localIP();
  //file3a = "str_URL2=\"http://" + String(ip[0]) + '.' + String(ip[1]) + '.' + String(ip[2]) + '.' + String(ip[3]) + "/led?\" + str_URL;";
  if (!MDNS.begin("esp8266")) {
    Serial.println("Error setting up MDNS responder!");
    while (1) {
      delay(1000);
    }
  }
  Serial.println("mDNS responder started");
  // Start TCP (HTTP) server
  server.begin();
  Serial.println("TCP server started");
  // Add service to MDNS-SD
  MDNS.addService("http", "tcp", 80);

  /*------------------------^^^------------------------------------*/
  /*вариант1
    WiFi.mode(WIFI_AP);
    // Do a little work to get a unique-ish name. Append the
    // last two bytes of the MAC (HEX'd) to "ThingDev-":
    uint8_t mac[WL_MAC_ADDR_LENGTH];
    WiFi.softAPmacAddress(mac);
    String macID = String(mac[WL_MAC_ADDR_LENGTH - 2], HEX) +
                   String(mac[WL_MAC_ADDR_LENGTH - 1], HEX);
    macID.toUpperCase();
    String AP_NameString = "ThingDev-" + macID;

    char AP_NameChar[AP_NameString.length() + 1];
    memset(AP_NameChar, 0, AP_NameString.length() + 1);

    for (int i = 0; i < AP_NameString.length(); i++)
      AP_NameChar[i] = AP_NameString.charAt(i);

    WiFi.softAP(AP_NameChar, WiFiAPPSK);

    server.begin();
    IPAddress ip = WiFi.softAPIP();
  //  file3a = "str_URL2=\"http://" + String(ip[0]) + '.' + String(ip[1]) + '.' + String(ip[2]) + '.' + String(ip[3]) + "/led?\" + str_URL;";
    Serial.println("");                    //для определения IP через терминал
    Serial.print("IP address: ");        //для определения IP через терминал
    Serial.println(WiFi.softAPIP());     //для определения IP через терминал
  */
}

void loop()
{
  cikl_current += 1; //приблизительно одна сек.
  //-==- внутренний таймер -======
  if (cikl_current >=  5000) {  //приблизительно 3 сек.
    //Serial.print('.');
    cikl_current = 0;
    cikl_count += 1;
    if (tt_time != 0 && cikl_count >= tt_time) {  //приблизительно 3 сек.
      cikl_count = 0;
      sborka();             //сбор и передача параметров.
    }
  }

  //-=============================
  //  WiFiClient client = server.available(); //так было ruben
  client = server.available();
  if (!client) {
    return;
  }
  // Read the first line of the request
  String req = client.readStringUntil('\r');
  Serial.print("From client: ");
  Serial.println(req);
  priem = req;
  mess = "";
  analis();
  delay(1);
  Serial.println("Client disonnected");
  delay(100);
}

String ex_link = "";
String ex_ip = "";
String temp_ip = "192.168.0.128";
int ind1, ind2;
//===========================
void analis()
{
  boolean fl_mess = true;
  //  Serial.println("call " + priem);
  ex_ip = "";
  ex_link = "";
  ind1 = priem.indexOf("?ip=");              //это внешний запрос?
  if (ind1 >= 0) {                           //да  &ip=192.168.0.128;map:cb12=1
    ind1 = priem.indexOf("=");              //это внешний запрос?
    ind2 = priem.indexOf(';');
    ex_ip = priem.substring(ind1 + 1, ind2);    //ip запроса
    //    Serial.println(ex_ip);
    priem.remove(0, ind2 + 1);             //

  } else {                                  //удаляем все вплоть до "?"
    ind1 = priem.indexOf('?');
    priem.remove(0, ind1 + 1);
  }
  //========проверка на прием IR кода=============================
  ind2 = priem.indexOf("result=");  //нам не интересно имя пульта
  if (ind2 >= 0) {                  //это ответ от другого модуля
    ex_analis(priem);                    //анализ строки
    /*
    priem.remove(0, ind2);          //убрали начало запроса
    priem = "Get " + priem;
    Serial.println("result mess "+ priem);
    out_mess(priem);               //просто переслать? или анализ в ex-mess();
    */
  } else {


    ind2 = priem.indexOf(':');     //GET /?map:cb0=0 HTTP/1.1  или  map:cb0=0 HTTP/1.1
    ex_link = priem.substring(0, ind2);    // map  - страничка запроса
    priem.remove(0, ind2 + 1);           //cb0=0 HTTP/1.1
    //Serial.println("ex_link " + ex_link);
    //Serial.println("1- " + priem);
    ind2 = priem.indexOf('=');
    String zapros = priem.substring(0, ind2);    //cb0  (=0) или cbA0
    //  Serial.println("2- " + zapros);
    //==================================================
    String vetka = zapros.substring(0, 2);       //cb
    //  Serial.println(zapros);
    zapros.remove(0, 2);                                   //2         или A0
    //  Serial.println("3- " + vetka);
    if (zapros != "A0") {
      pin = zapros.toInt();                     //Аналоговый вход A0 = 20
    } else {
      pin = 20;
    }
    priem.remove(0, ind2 + 1);          //оставить все после знака =  0 HTTP/1.1
    ind1 = priem.indexOf(' ');          //найти пробел
    zapros = priem.substring(0, ind1);  //все до пробела    0
    sos = zapros.toInt();               //преобразовали значение в цифру
    //int vol_sos = sos;
    if (vetka == "GE" or vetka == "ne")     //первый запрос- обновить страницу, проверка
    {
      client.flush();
      for (int i = 0; i < 6; i++)
      { mess = string_table[i];
        client.print(mess);
        delay( 10 );
      }
    } else {
      //out_mess("Get result=&out2=34&out1=19&out3=test");  //проверка обратной связи @test@
      if (vetka == "cb" || vetka == "vv")          //on/off
      {
        analogWrite(pin, 0);
        digitalWrite(pin, 1 - sos); //только для твердотельного реле
        mess = "digitalWrite(GPIO";
      } else {
        fl_mess = false;
        if (vetka == "zz") { //сбор и передача параметров на центральный сервер 192.168.0.128
          sborka();
        } else {
          if (vetka == "ce") {
            out_mess("Get result=&out2=34&out1=19&out3=test");
          } else {
            if (vetka == "ir") {
              ir_send(); //send_ircod();
              // out_mess("Get result=&out2=34&out1=19&out3=test");
            } else {
              if (vetka == "tt") {
                Serial.println("***0***" + vetka);
                tt_time = sos;
                //ex_ip = "192.168.0.128";
                //out_mess("?map:result=&out2=34&out1=19&out3=test");
              }
            }
          }
        }
      }
      if (fl_mess) {
        form_mess(mess, pin, sos);
      }
    }
  Serial.println("vetka - " + vetka + ", pin - " + pin + ", vol - " + sos);
  }
}

void ex_analis(String ex_priem)
{ // &ip=192.168.0.166;result=&rate=38&code_len=68&ir=1000;4450;465...
  //  /map?result=&16=0&5=0&4=1023&0=0&12=1023&13=1023
  //Serial.println("ex***= " + ex_priem);
  ind1 = ex_priem.indexOf("&rate");
  if (ind1 >= 0) {
    ex_priem.remove(0, ind1+1); //rate=38&code_len=68&ir=1000;4450;465...
    ind1 = ex_priem.indexOf('=');
    ind2 = ex_priem.indexOf('&');
    cod_khz = ex_priem.substring(ind1 + 1, ind2).toInt();
    ex_priem.remove(0, ind2 + 1); //code_len=68&ir=1000;4450;465...
    //==
    if (ex_priem.indexOf("code_len") >= 0)ex_priem.remove(0, ind1); //перестраховка
    ind1 = ex_priem.indexOf('=');
    ind2 = ex_priem.indexOf('&');
    cod_len = ex_priem.substring(ind1 + 1, ind2).toInt();
    ex_priem.remove(0, ind2 + 1); //ir=1000;4450;465...
    ind1 = ex_priem.indexOf("ir=");
    if (ind1 >= 0)ex_priem.remove(0, ind1); //перестраховка
    Serial.println("ex*4*= " + ex_priem);
    ind1 = ex_priem.indexOf('=');
    ex_priem.remove(0, ind1+1); //1000;4450;465...
    priem = ex_priem;
    ir_send();
  }
  /*
  }
  ind1 = ex_priem.indexOf('?');
  modul_name  =  ex_priem.substring(1, ind1);   //map
  ind1 = ex_priem.indexOf("result=");
  if (ind1 >= 0) {
    ex_priem.remove(0, ind1);     //result=&16=0&5=0&4=1023&0=0&12=1023&13=1023
    ind1 = ex_priem.indexOf("=");
    ex_priem.remove(0, ind1 + 1);   //&16=0&5=0&4=1023&0=0&12=1023&13=1023
    if (modul_name == "map") {
      //par_map = ex_priem;
      par_map = param_mess(ex_priem, out_map, ';');
      //    Serial.println("par_map= "+par_map);
    } else {
      if (modul_name == "rozetka") {
        //par_rozetka = ex_priem;
        par_rozetka = param_mess(ex_priem, out_rozetka, ';');
      }
    }
  }
  */
}

unsigned int temp_int_array[76];
unsigned int temp_int;
String temp_str;
void ir_send() {           //priem send_ircod();
//  Serial.println("priem " + priem);
  for (int i = 0; i < 76; i++) temp_int_array[i] = (char)0;
  int count_arr = 0;
  ind1 = priem.indexOf(';'); //обязательно перед циклом
  while (ind1 >= 0) {
    temp_str = priem.substring(0, ind1); //записали цифровое значение импульса)
    priem.remove(0, ind1 + 1);          //удалили считанную часть
    temp_int = temp_str.toInt();
    temp_int_array[count_arr] =  temp_int;
    //    (unsigned int)temp_str.toInt;
    count_arr += 1;
    ind1 = priem.indexOf(';');
  }
  Serial.println();
  //проверка идентичности с  массивом в основном модуле (ведущем)
  for (int i = 0; i < 75; i++) {
    Serial.print(String(temp_int_array[i]) + ';');
  }
  Serial.println();
  
  //Serial.print("cod_len= ");Serial.print(cod_len);Serial.print("; cod_khz= ");Serial.println(cod_khz);
  //  irsend.sendRaw(temp_int_array, 68, 38); //Note the approach used to automatically calculate the size of the array.
  irsend.sendRaw(temp_int_array, cod_len, cod_khz); //Note the approach used to automatically calculate the size of the array.
//  irrecv.enableIRIn(); // разрешить receiver
//  irrecv.resume();     // принять следующий код
}

void sborka() {
  ex_ip = temp_ip;   //"192.168.0.128"; //должны получить при внешнем запросе
  out_mess (obzor());           //("result=&out2=34&out1=19&out3=test");
}

String obzor() {       //состояние элементов управления
  String result;
  result = "result=&fan=" + String(digitalRead(12));
  //  server.send(200, "text/plain", result); //из другой оперы
  return result;
}

void form_mess(String m_str, int spin, int ssos) {
  if (ex_ip == "") {
    mess = "Get result=&ex_out=" + m_str;
  } else {
    mess = "result=" + m_str;
  }
  if (spin != 20) {
    mess += spin;
  } else {
    mess += "A0";
  }
  if (ssos != -1) {
    mess += ", ";
    if (ssos == -2) {
      mess += "OUTPUT";
    } else {
      if (ssos == -3) {
        mess += "INPUT";
      } else    mess += ssos;
    }
    mess += ");";
  }
  out_mess(mess);
}

void out_mess(String m_str)
{
  if (ex_ip != "") {
    convert_ip();             //ex_ip
    if (client.connect(out_ip, 80)) {
      Serial.print("connected - ");
      client.flush();
      m_str = "/" + ex_link + "?" + m_str;
      client.println(m_str);
      client.println();
    }
  } else {
    client.flush();
    // mess = "HTTP / 1.1 200 OK\r\n";                 //ruben
    // mess += "Content - Type: text / html\r\n\r\n";  //ruben
    client.print(m_str);
  }
  Serial.println(m_str);
}

void convert_ip(void) {
  priem = ex_ip;                 //ip в чистом виде 192.168.0.121
  temp_ip = ex_ip;               //запомнили для передачи параметров по таймеру
  for (int i = 0; i < 3; i++) {
    ind2 = priem.indexOf('.');     //192.168.0.   121/?
    out_ip[i] =  priem.substring(0, ind2).toInt();
    priem.remove(0, ind2 + 1);
    //Serial.println(cod_note);  //test
  }
  out_ip[3] =  priem.toInt();
}

void INTERRUPT_ok()
{
  Serial.print("INTERRUPT ok - ");
  Serial.println(pin);
}

void initHardware()
{
  irsend.begin();
  Serial.begin(115200);
  pinMode(12, OUTPUT);
  pinMode(13, OUTPUT);
  digitalWrite(12, 0);
  digitalWrite(13, 0);
  //  led_blink(6, 100, 200); //число включений, темная пауза, яркая пауза
}


